Customization of AI Assistant

18 Nov 201824 minutes to read

The AI Assistant feature is designed to be easily customizable using its properties, public methods, and events. The following examples demonstrate the customizations in the AI Assistant by adding custom toolbar buttons to the Prompt, Response, and Header toolbars, styling the AI Assistant popup, and using public methods to demonstrate a proofread use case.

Custom Toolbar Buttons in AI Assistant

To add the custom toolbar items to the AI Assistant Header, Prompt, and Response toolbar, the headerToolbarSettings, promptToolbarSettings, and responseToolbarSettings properties of the aiAssistantSettings can be used. The aiAssistantToolbarClick event allows you to execute custom logic when toolbar buttons are clicked.

The Custom items can be added to the headerToolbarSettings, promptToolbarSettings, and responseToolbarSettings with the following properties.

Property Description
command Specifies the primary command to execute when the toolbar item action is triggered.
subCommand Specifies the secondary or sub-command to execute when the toolbar item action is triggered.
iconCss Specifies the CSS class for the icon displayed in the toolbar item.
text Specifies the display text of the toolbar item.
type Specifies the type of the toolbar item (default is Button).
align Specifies the alignment of the toolbar item within the toolbar (default is Left).
visible Determines whether the toolbar item is visible (default is true).
disabled Determines whether the toolbar item is disabled and non-interactive (default is false).
tooltip Specifies the tooltip text shown when hovering over the toolbar item.
cssClass Specifies additional CSS classes applied to the toolbar item for styling.
template Specifies a custom template for rendering the toolbar item; can be a string or a function depending on the framework.
tabIndex Specifies the tab order of the toolbar item for keyboard navigation (default is -1).

Example

In the following example, custom toolbar items are added to the Header, Prompt, and Response toolbars of the AI Assistant, along with corresponding event handling logic.

  1. Custom Header Toolbar Item

    • A User Profile dropdown is added as a custom header toolbar item using a template.
    • The DropDownButton component is dynamically initialized in the beforePopupOpen event when the AI Assistant popup opens.
    • The dropdown instance is properly destroyed in the beforePopupClose event to ensure clean resource management.
  2. Custom Prompt Toolbar Item

    • A Search in Google toolbar button is added to the prompt toolbar.
    • When the button is clicked, the current prompt text is retrieved and used to open a new browser tab with the corresponding Google search results.
  3. Custom Response Toolbar Item

    • A Save toolbar button is added to the response toolbar.
    • On clicking the button, the generated AI response content is extracted from the response container and can be processed further (for example, saving it to a database or local storage).
<template>
  <div>
    <div class="control-section">
      <div class="sample-container">
        <div class="default-section">
          <ejs-richtexteditor 
            id="default" 
            ref="rteInstance" 
            :toolbarSettings="toolbarSettings" 
            :aiAssistantSettings="aiAssistantSettings" 
            @aiAssistantToolbarClick="onAIAssistantToolbarClick"
            @beforePopupOpen="beforePopupOpen" 
            @beforePopupClose="beforePopupClose">
          </ejs-richtexteditor>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { provide, ref } from 'vue';
import { RichTextEditorComponent as EjsRichtexteditor, Toolbar, Link, Image, HtmlEditor, AIAssistant } from "@syncfusion/ej2-vue-richtexteditor";
import { DropDownButton } from '@syncfusion/ej2-splitbuttons';

const rteInstance = ref(null);
const userDropDown = ref(null);

const toolbarSettings = {
  items: ['AICommands', 'AIQuery']
};

const aiAssistantSettings = {
  promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
  responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
  headerToolbarSettings: ['AIcommands', 
    { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close'
  ],
  prompts: [
    {
      prompt: 'What is Essential Studio ?',
      response: 'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
    },
  ],
};
const onAIAssistantToolbarClick = (args) => {
  if (args.item.iconCss === 'e-icons e-open-link') {
    const target = args.event.target;
    const promptContainer = target.closest('.e-prompt-container');
    if (promptContainer) {
      const prompt = promptContainer.querySelector('.e-prompt-text').textContent;
      window.open(`https://www.google.com/search?q=${encodeURIComponent(prompt)}`, '_blank');
    }
  } else if (args.item.iconCss === 'e-icons e-save') {
    const outputContainer = args.event.currentTarget.closest('.e-output-container');
    if (outputContainer) {
      const response = outputContainer.querySelector('.e-content-body').innerHTML;
      console.log('Response saved:', response);
    }
  }
};
const beforePopupOpen = (event) => {
  if (event.type === 'AIAssistant') {
    // Use nextTick to ensure DOM is ready
    setTimeout(() => {
      const profileDropDown = event.element.querySelector('#profileDropDown');
      if (profileDropDown) {
        console.log('Creating DropDownButton...');
        
        // Destroy existing instance if it exists
        if (userDropDown.value) {
          userDropDown.value.destroy();
        }
        userDropDown.value = new DropDownButton({
          items: [
            { text: 'Usage', iconCss: 'e-icons e-chart' },
            { text: 'Saved Response', iconCss: 'e-icons e-save' },
            { separator: true },
            { text: 'Log out', iconCss: 'e-icons e-view-side' }
          ],
          iconCss: 'e-icons e-user',
          cssClass: 'e-caret-hide',
        }, profileDropDown);
        
        console.log('DropDownButton created:', userDropDown.value);
      }
    }, 0);
  }
};
const beforePopupClose = (event) => {
  if (event.type === 'AIAssistant') {
    if (userDropDown.value) {
      userDropDown.value.destroy();
      userDropDown.value = null;
      console.log('DropDownButton destroyed');
    }
  }
};

const richtexteditor = [Toolbar, Link, Image, HtmlEditor, AIAssistant];
provide('richtexteditor', richtexteditor);
</script>

<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-interactive-chat/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-notifications/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css"; 
</style>
<template>
  <div>
    <div class="control-section">
      <div class="sample-container">
        <div class="default-section">
          <ejs-richtexteditor 
            id="default" 
            ref="rteInstance" 
            :toolbarSettings="toolbarSettings" 
            :aiAssistantSettings="aiAssistantSettings" 
            @aiAssistantToolbarClick="onAIAssistantToolbarClick"
            @beforePopupOpen="beforePopupOpen" 
            @beforePopupClose="beforePopupClose">
          </ejs-richtexteditor>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { RichTextEditorComponent, Toolbar, Link, Audio, HtmlEditor, AIAssistant } from "@syncfusion/ej2-vue-richtexteditor";
import { DropDownButton } from '@syncfusion/ej2-splitbuttons';

export default {
  name: "App",
  components: {
    "ejs-richtexteditor": RichTextEditorComponent
  },
  data: function() {
    return {
      userDropDown: null,
      toolbarSettings: {
        items: ['AICommands', 'AIQuery']
      },
      aiAssistantSettings: {
         promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands', 
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
      }
    };
  },
  methods: {
    onAIAssistantToolbarClick: function(args) {
      if (args.item.iconCss === 'e-icons e-open-link') {
        const target = args.event.target;
        const promptContainer = target.closest('.e-prompt-container');
        if (promptContainer) {
          const prompt = promptContainer.querySelector('.e-prompt-text').textContent;
          window.open(`https://www.google.com/search?q=${prompt}`, '_blank');
        }
      } else if (args.item.iconCss === 'e-icons e-save') {
        const outputContainer = args.event.currentTarget.closest('.e-output-container');
        if (outputContainer) {
          const response = outputContainer.querySelector('.e-content-body').innerHTML;
          console.log('Response saved:', response);
        }
      }
    },
    beforePopupOpen: function(event) {
      if (event.type === 'AIAssistant') {
        const profileDropDown = event.element.querySelector('#profileDropDown');
        if (profileDropDown) {
          this.userDropDown = new DropDownButton({
            items: [
              { text: 'Usage', iconCss: 'e-icons e-chart' },
              { text: 'Saved Response', iconCss: 'e-icons e-save' },
              { separator: true },
              { text: 'Log out', iconCss: 'e-icons e-view-side' }
            ],
            iconCss: 'e-icons e-user',
            cssClass: 'e-caret-hide',
          }, profileDropDown);
        }
      }
    },
    beforePopupClose: function(event) {
      if (event.type === 'AIAssistant') {
        this.userDropDown.destroy();
      }
    }
  },
  provide: {
    richtexteditor: [Toolbar, Link, Audio, HtmlEditor, AIAssistant]
  }
}
</script>

<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-interactive-chat/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-notifications/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css"; 
</style>

Styling the Popup

The AI Assistant Popup can be styled by using the following css.

.e-rte-aiquery-popup {
    padding:2px;
}

The AI Assistant Popup processing state can be styled by using the following css.

.e-rte-aiquery-popup.processing {
    padding:2px;
    color: white;
    background: white;
    z-index: 1;
}

Example

In the following example, a CSS animation is applied to the popup while the request is in progress.

<template>
    <div>
        <div class="control-section">
            <div class="sample-container">
                <div class="default-section">
                <ejs-richtexteditor 
                    id="default" 
                    ref="rteInstance" 
                    :toolbarSettings="toolbarSettings"
                    @aiAssistantRequest="onPromptRequest">
                </ejs-richtexteditor>
                </div>
            </div>
        </div>
    </div>
</template>
<script setup>
import { provide, ref } from 'vue';
import { RichTextEditorComponent as EjsRichtexteditor, Toolbar, Link, Image, HtmlEditor, AIAssistant } from "@syncfusion/ej2-vue-richtexteditor";
const rteInstance = ref(null);
const toolbarSettings = {
            items: ['AICommands', 'AIQuery']
        };
const onPromptRequest = (event) => {
  setTimeout(() => {
        rteInstance.value.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', false);
        rteInstance.value.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', true);
      }, 5000);
}; 
const richtexteditor = [Toolbar, Link, Image, HtmlEditor, AIAssistant];
provide('richtexteditor', richtexteditor);
</script>
<style>
    @import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-interactive-chat/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-notifications/styles/tailwind3.css";
    @import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css"; 
</style>
<template>
  <div>
    <div class="control-section">
      <div class="sample-container">
        <div class="default-section">
          <ejs-richtexteditor 
            id="default" 
            ref="rteInstance" 
            :toolbarSettings="toolbarSettings"
            @aiAssistantRequest="onPromptRequest">
          </ejs-richtexteditor>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { RichTextEditorComponent, Toolbar, Link, Audio, HtmlEditor, AIAssistant } from "@syncfusion/ej2-vue-richtexteditor";

export default {
  name: "App",
  components: {
    "ejs-richtexteditor": RichTextEditorComponent
  },
  data: function() {
    return {
      toolbarSettings: {
        items: ['AICommands', 'AIQuery']
      }
    };
  },
  methods: {
    onPromptRequest: function(event) {
      setTimeout(() => {
        const rteInstance = this.$refs.rteInstance.ej2Instances;
        rteInstance.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', false);
        rteInstance.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', true);
      }, 5000);
    }
  },
  provide: {
    richtexteditor: [Toolbar, Link, Audio, HtmlEditor, AIAssistant]
  }
}
</script>

<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-interactive-chat/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-notifications/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css"; 
</style>

Use Case

Using the public methods, you can build custom workflows with the AI Assistant. Actions such as retrieving conversation history, executing prompts, adding responses, showing or hiding the AI Assistant, and clearing conversation history can all be achieved using the following public methods programmatically.

Method Description
getAIPromptHistory() Get conversation history.
executeAIPrompt(prompt: string) Send a prompt to the AI Assistant.
addAIPromptResponse(outputResponse: string \| Object, isFinalUpdate?: boolean) Adds the Response to the AI Assistant.
showAIAssistantPopup() Show the AI Assistant popup.
hideAIAssistantPopup() Hide the AI Assistant popup.
clearAIPromptHistory() Clear all conversation history.

Example

The following example demonstrates a Proofread use case by rendering a button outside the editor. On clicking the Proofread button:

  1. Launches the AI Assistant popup using the showAIAssistantPopup method.
  2. Executes a prompt using the executeAIPrompt method.
<template>
  <div>
    <div class="control-section">
      <div class="sample-container">
        <div class="default-section">
          <ejs-richtexteditor 
            id="default" 
            ref="rteInstance" 
            :toolbarSettings="toolbarSettings"
            @aiAssistantRequest="onPromptRequest">
            <p>Dear valued costumer,</p>
            <p>We are writting to inform you that there has been a recent change to our policy's which may effect your account. Please take a moment to review the detials below carefuly.</p>
            <p>Starting from next monday, all user must update there personal information before accessing the system. Failure to do so may result in temporary suspension of you're account, and loss of acces to certain feature.</p>
            <p>If you have any question or concern, feel free to contact our support team at <a href="mailto:support&#64;companyname.com">support&#64;companyname.com</a> they are avalible 24/7 and happy help.</p>
            <p>Thank you for you're time and coorperation. We appologize for any inconvenient this may cause.</p>
            <p>Best Regard,</p>
            <p>Customer Support Team</p>
            <p>Company Name</p>
          </ejs-richtexteditor>
          <br>
          <button class="e-btn e-primary" @click="reviewContent()">
            <span class="e-icons e-btn-icon e-check-large"></span>Proof read
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { provide, ref } from 'vue';
import { RichTextEditorComponent as EjsRichtexteditor, Toolbar, Link, Image, HtmlEditor, AIAssistant } from "@syncfusion/ej2-vue-richtexteditor";

const rteInstance = ref(null);

const toolbarSettings = {
  items: ['AICommands', 'AIQuery']
};
const onPromptRequest = (event) => {
  setTimeout(() => {
    const aiResponse = `Dear Valued Customer,
We are writing to inform you that there has been a recent change to our policies that may affect your account. Please take a moment to review the details below carefully.
Starting next Monday, all users must update their personal information before accessing the system. Failure to do so may result in the temporary suspension of your account and loss of access to certain features.
If you have any questions or concerns, please feel free to contact our support team at [email protected]. They are available 24/7 and happy to help.
Thank you for your time and cooperation. We apologize for any inconvenience this may cause.
Best regards,
Customer Support Team
Company Name
`;
    rteInstance.value.addAIPromptResponse(aiResponse, false);
    rteInstance.value.addAIPromptResponse(aiResponse, true);
  }, 300);
};
const reviewContent = () => {
  rteInstance.value.showAIAssistantPopup();
  rteInstance.value.executeAIPrompt('Proof read the editor content.');
};

const richtexteditor = [Toolbar, Link, Image, HtmlEditor, AIAssistant];
provide('richtexteditor', richtexteditor);
</script>

<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-interactive-chat/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-notifications/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css"; 
</style>
<template>
  <div>
    <div class="control-section">
      <div class="sample-container">
        <div class="default-section">
          <ejs-richtexteditor 
            id="default" 
            ref="rteInstance" 
            :toolbarSettings="toolbarSettings"
            @aiAssistantRequest="onPromptRequest">
            <p>Dear valued costumer,</p>
            <p>We are writting to inform you that there has been a recent change to our policy's which may effect your account. Please take a moment to review the detials below carefuly.</p>
            <p>Starting from next monday, all user must update there personal information before accessing the system. Failure to do so may result in temporary suspension of you're account, and loss of acces to certain feature.</p>
            <p>If you have any question or concern, feel free to contact our support team at <a href="mailto:support&#64;companyname.com">support&#64;companyname.com</a> they are avalible 24/7 and happy help.</p>
            <p>Thank you for you're time and coorperation. We appologize for any inconvenient this may cause.</p>
            <p>Best Regard,</p>
            <p>Customer Support Team</p>
            <p>Company Name</p>
          </ejs-richtexteditor>
          <br>
          <button class="e-btn e-primary" @click="reviewContent()">
            <span class="e-icons e-btn-icon e-check-large"></span>Proof read
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { RichTextEditorComponent, Toolbar, Link, Audio, HtmlEditor, AIAssistant } from "@syncfusion/ej2-vue-richtexteditor";

export default {
  name: "App",
  components: {
    "ejs-richtexteditor": RichTextEditorComponent
  },
  data: function() {
    return {
      toolbarSettings: {
        items: ['AICommands', 'AIQuery']
      }
    };
  },
  methods: {
    onPromptRequest: function(event) {
      setTimeout(() => {
        const rteInstance = this.$refs.rteInstance.ej2Instances;
    const aiResponse = `Dear Valued Customer,
We are writing to inform you that there has been a recent change to our policies that may affect your account. Please take a moment to review the details below carefully.
Starting next Monday, all users must update their personal information before accessing the system. Failure to do so may result in the temporary suspension of your account and loss of access to certain features.
If you have any questions or concerns, please feel free to contact our support team at [email protected]. They are available 24/7 and happy to help.
Thank you for your time and cooperation. We apologize for any inconvenience this may cause.
Best regards,
Customer Support Team
Company Name
`;
    rteInstance.addAIPromptResponse(aiResponse, false);
    rteInstance.addAIPromptResponse(aiResponse, true);
  }, 300);
    },
    reviewContent: function() {
        const rteInstance = this.$refs.rteInstance.ej2Instances;
        rteInstance.showAIAssistantPopup();
    rteInstance.executeAIPrompt('Proof read the editor content.');
    }
  },
  provide: {
    richtexteditor: [Toolbar, Link, Audio, HtmlEditor, AIAssistant]
  }
}
</script>

<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-interactive-chat/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-notifications/styles/tailwind3.css";
  @import "../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css"; 
</style>

Customization of AI Assistant

18 Nov 201819 minutes to read

The AI Assistant feature is designed to be easily customizable using its properties, public methods, and events. The following examples demonstrate the customizations in the AI Assistant by adding custom toolbar buttons to the Prompt, Response, and Header toolbars, styling the AI Assistant popup, and using public methods to demonstrate a proofread use case.

Custom Toolbar Buttons in AI Assistant

To add the custom toolbar items to the AI Assistant Header, Prompt, and Response toolbar, the headerToolbarSettings, promptToolbarSettings, and responseToolbarSettings properties of the aiAssistantSettings can be used. The aiAssistantToolbarClick event allows you to execute custom logic when toolbar buttons are clicked.

The Custom items can be added to the headerToolbarSettings, promptToolbarSettings, and responseToolbarSettings with the following properties.

Property Description
command Specifies the primary command to execute when the toolbar item action is triggered.
subCommand Specifies the secondary or sub-command to execute when the toolbar item action is triggered.
iconCss Specifies the CSS class for the icon displayed in the toolbar item.
text Specifies the display text of the toolbar item.
type Specifies the type of the toolbar item (default is Button).
align Specifies the alignment of the toolbar item within the toolbar (default is Left).
visible Determines whether the toolbar item is visible (default is true).
disabled Determines whether the toolbar item is disabled and non-interactive (default is false).
tooltip Specifies the tooltip text shown when hovering over the toolbar item.
cssClass Specifies additional CSS classes applied to the toolbar item for styling.
template Specifies a custom template for rendering the toolbar item; can be a string or a function depending on the framework.
tabIndex Specifies the tab order of the toolbar item for keyboard navigation (default is -1).

Example

In the following example, custom toolbar items are added to the Header, Prompt, and Response toolbars of the AI Assistant, along with corresponding event handling logic.

  1. Custom Header Toolbar Item

    • A User Profile dropdown is added as a custom header toolbar item using a template.
    • The DropDownButton component is dynamically initialized in the beforePopupOpen event when the AI Assistant popup opens.
    • The dropdown instance is properly destroyed in the beforePopupClose event to ensure clean resource management.
  2. Custom Prompt Toolbar Item

    • A Search in Google toolbar button is added to the prompt toolbar.
    • When the button is clicked, the current prompt text is retrieved and used to open a new browser tab with the corresponding Google search results.
  3. Custom Response Toolbar Item

    • A Save toolbar button is added to the response toolbar.
    • On clicking the button, the generated AI response content is extracted from the response container and can be processed further (for example, saving it to a database or local storage).
<ejs-richtexteditor [toolbarSettings]="toolbarSettings" [aiAssistantSettings]="aiAssistantSettings" (aiAssistantToolbarClick)="onAIAssistantToolbarClick($event)"
    (beforePopupOpen)="beforePopupOpen($event)" (beforePopupClose)="beforePopupClose($event)">
</ejs-richtexteditor>
import { Component } from '@angular/core';
import { RichTextEditorModule, ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, AIAssistantService, AIAssistantSettingsModel, ToolbarSettingsModel, AIAssitantToolbarClickEventArgs, BeforePopupOpenCloseEventArgs } from '@syncfusion/ej2-angular-richtexteditor';
import { DropDownButton } from '@syncfusion/ej2-splitbuttons';
@Component({
    imports: [RichTextEditorModule],
    standalone: true,
    templateUrl: 'app.component.html',
    selector: 'app-root',
    providers: [ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, AIAssistantService],
})
export class AppComponent {

    public toolbarSettings: ToolbarSettingsModel = { items: ['AICommands', 'AIQuery'] };

    public userDropDown!: DropDownButton;

    public aiAssistantSettings: AIAssistantSettingsModel = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands', 
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };

    onAIAssistantToolbarClick(args: AIAssitantToolbarClickEventArgs) {
        if (args.item.iconCss === 'e-icons e-open-link') {
            const target: HTMLElement= args.originalEvent.target as HTMLElement;
            const promptContainer: HTMLElement = target.closest('.e-prompt-container') as HTMLElement;
            const prompt = (promptContainer.querySelector('.e-prompt-text') as HTMLElement).textContent;
            window.open(`https://www.google.com/search?q=${prompt}`, '_blank')
        } else if (args.item.iconCss === 'e-icons e-save') {
            const response = (args as any).event.currentTarget.closest('.e-output-container').querySelector('.e-content-body').innerHTML;
            console.log(response); // Handle Saving response here.
        }
    };

    beforePopupOpen(event: BeforePopupOpenCloseEventArgs) {
        if (event.type === 'AIAssistant') {
            this.userDropDown = new DropDownButton({
                items: [
                    { text: 'Usage', iconCss: 'e-icons e-chart' },
                    { text: 'Saved Response' , iconCss: 'e-icons e-save'},
                    { separator: true },
                    { text: 'Log out', iconCss: 'e-icons e-view-side' }
                ],
                iconCss: 'e-icons e-user',
                cssClass: 'e-caret-hide',
            }, event.element.querySelector('#profileDropDown') as HTMLButtonElement);
        }
    }

    beforePopupClose(event: BeforePopupOpenCloseEventArgs) {
        if (event.type === 'AIAssistant') {
            this.userDropDown.destroy();
        }
    }
}

Styling the Popup

The AI Assistant Popup can be styled by using the following css.

.e-rte-aiquery-popup {
    padding:2px;
}

The AI Assistant Popup processing state can be styled by using the following css.

.e-rte-aiquery-popup.processing {
    padding:2px;
    color: white;
    background: white;
    z-index: 1;
}

Example

In the following example, a CSS animation is applied to the popup while the request is in progress.

.e-rte-aiquery-popup.processing {
    padding:2px;
    color: white;
    background: white;
    z-index: 1;
}

.e-rte-aiquery-popup.processing::before {
    content: "";
    position: absolute;
    top: -2px;
    left: -2px;
    right: -2px;
    bottom: -2px;
    background: linear-gradient(270deg, #ff0080, #7928ca, #2afadf, #ff0080);
    background-size: 600% 600%;
    border-radius: 10px;
    animation: gradient-animation 8s ease infinite;
}

.e-rte-aiquery-popup.processing::after {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background:white;
    border-radius: 6px;
    z-index: -1;
}

@keyframes gradient-animation {
    0% {
        background-position: 0% 50%;
    }

    50% {
        background-position: 100% 50%;
    }

    100% {
        background-position: 0% 50%;
    }
}
<ejs-richtexteditor #editor [toolbarSettings]="toolbarSettings" (aiAssistantPromptRequest)="onPromptRequest($event)">
</ejs-richtexteditor>
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorModule, ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, AIAssistantService, ToolbarSettingsModel, AIAssistantPromptRequestArgs, editAreaClick, RichTextEditorComponent } from '@syncfusion/ej2-angular-richtexteditor';
@Component({
    imports: [RichTextEditorModule],
    standalone: true,
    templateUrl: 'app.component.html',
    styleUrl:  'app.component.css',
    selector: 'app-root',
    providers: [ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, AIAssistantService],
})
export class AppComponent {
    @ViewChild('editor')
    public editor!: RichTextEditorComponent;
    public toolbarSettings: ToolbarSettingsModel = { items: ['AICommands', 'AIQuery'] };

    onPromptRequest(event:AIAssistantPromptRequestArgs): void {
        setTimeout(() => {
            this.editor.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', false);
            this.editor.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', true);
        }, 5000);
    }
}

Use Case

Using the public methods, you can build custom workflows with the AI Assistant. Actions such as retrieving conversation history, executing prompts, adding responses, showing or hiding the AI Assistant, and clearing conversation history can all be achieved using the following public methods programmatically.

Method Description
getAIPromptHistory() Get conversation history.
executeAIPrompt(prompt: string) Send a prompt to the AI Assistant.
addAIPromptResponse(outputResponse: string \| Object, isFinalUpdate?: boolean) Adds the Response to the AI Assistant.
showAIAssistantPopup() Show the AI Assistant popup.
hideAIAssistantPopup() Hide the AI Assistant popup.
clearAIPromptHistory() Clear all conversation history.

Example

The following example demonstrates a Proofread use case by rendering a button outside the editor. On clicking the Proofread button:

  1. Launches the AI Assistant popup using the showAIAssistantPopup method.
  2. Executes a prompt using the executeAIPrompt method.
<ejs-richtexteditor #editor [toolbarSettings]="toolbarSettings" (aiAssistantPromptRequest)="onPromptRequest($event)">
    <ng-template #valueTemplate>
        <p>Dear valued costumer,</p>
        <p>We are writting to inform you that there has been a recent change to our policy’s which may effect your account. Please take a moment to review the detials below carefuly.</p>
        <p>Starting from next monday, all user must update there personal information before accessing the system. Failure to do so may result in temporary suspension of you’re account, and loss of acces to certain feature.</p>
        <p>If you have any question or concern, feel free to contact our support team at <a href="mailto:support&#64;companyname.com">support&#64;companyname.com</a> they are avalible 24/7 and happy help.</p>
        <p>Thank you for you’re time and coorperation. We appologize for any inconvenient this may cause.</p>
        <p>Best Regard,</p>
        <p>Customer Support Team</p>
        <p>Company Name</p>
    </ng-template>
</ejs-richtexteditor>

<br>
<button class="e-btn e-primary" (click)="reviewContent()"><span class="e-icons e-btn-icon e-check-large"></span>Proof read</button>
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorModule, ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, AIAssistantService, ToolbarSettingsModel, AIAssistantPromptRequestArgs, editAreaClick, RichTextEditorComponent } from '@syncfusion/ej2-angular-richtexteditor';
@Component({
    imports: [RichTextEditorModule],
    standalone: true,
    templateUrl: 'app.component.html',
    selector: 'app-root',
    providers: [ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, AIAssistantService],
})
export class AppComponent {
    @ViewChild('editor')
    public editor!: RichTextEditorComponent;
    public toolbarSettings: ToolbarSettingsModel = { items: ['AICommands', 'AIQuery'] };

    onPromptRequest(event:AIAssistantPromptRequestArgs): void {
        setTimeout(() => {
            const aiResponse: string = `Dear Valued Customer,

We are writing to inform you that there has been a recent change to our policies that may affect your account. Please take a moment to review the details below carefully.

Starting next Monday, all users must update their personal information before accessing the system. Failure to do so may result in the temporary suspension of your account and loss of access to certain features.

If you have any questions or concerns, please feel free to contact our support team at [[email protected]](mailto:[email protected]). They are available 24/7 and happy to help.

Thank you for your time and cooperation. We apologize for any inconvenience this may cause.

Best regards,
Customer Support Team
Company Name
`;
            this.editor.addAIPromptResponse(aiResponse, false);
            this.editor.addAIPromptResponse(aiResponse, true);
        }, 300); // For demonstration purpose.
    }

    reviewContent(): void {
        this.editor.showAIAssistantPopup();
        this.editor.executeAIPrompt('Proof read the editor content.');
    }
}

Customization of AI Assistant

18 Nov 201824 minutes to read

The AI Assistant feature is designed to be easily customizable using its properties, public methods, and events. The following examples demonstrate the customizations in the AI Assistant by adding custom toolbar buttons to the Prompt, Response, and Header toolbars, styling the AI Assistant popup, and using public methods to demonstrate a proofread use case.

Custom Toolbar Buttons in AI Assistant

To add the custom toolbar items to the AI Assistant Header, Prompt, and Response toolbar, the headerToolbarSettings, promptToolbarSettings, and responseToolbarSettings properties of the aiAssistantSettings can be used. The aiAssistantToolbarClick event allows you to execute custom logic when toolbar buttons are clicked.

The Custom items can be added to the headerToolbarSettings, promptToolbarSettings, and responseToolbarSettings with the following properties.

Property Description
command Specifies the primary command to execute when the toolbar item action is triggered.
subCommand Specifies the secondary or sub-command to execute when the toolbar item action is triggered.
iconCss Specifies the CSS class for the icon displayed in the toolbar item.
text Specifies the display text of the toolbar item.
type Specifies the type of the toolbar item (default is Button).
align Specifies the alignment of the toolbar item within the toolbar (default is Left).
visible Determines whether the toolbar item is visible (default is true).
disabled Determines whether the toolbar item is disabled and non-interactive (default is false).
tooltip Specifies the tooltip text shown when hovering over the toolbar item.
cssClass Specifies additional CSS classes applied to the toolbar item for styling.
template Specifies a custom template for rendering the toolbar item; can be a string or a function depending on the framework.
tabIndex Specifies the tab order of the toolbar item for keyboard navigation (default is -1).

Example

In the following example, custom toolbar items are added to the Header, Prompt, and Response toolbars of the AI Assistant, along with corresponding event handling logic.

  1. Custom Header Toolbar Item

    • A User Profile dropdown is added as a custom header toolbar item using a template.
    • The DropDownButton component is dynamically initialized in the beforePopupOpen event when the AI Assistant popup opens.
    • The dropdown instance is properly destroyed in the beforePopupClose event to ensure clean resource management.
  2. Custom Prompt Toolbar Item

    • A Search in Google toolbar button is added to the prompt toolbar.
    • When the button is clicked, the current prompt text is retrieved and used to open a new browser tab with the corresponding Google search results.
  3. Custom Response Toolbar Item

    • A Save toolbar button is added to the response toolbar.
    • On clicking the button, the generated AI response content is extracted from the response container and can be processed further (for example, saving it to a database or local storage).

[Class-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import { DropDownButton } from '@syncfusion/ej2-splitbuttons';
import * as React from 'react';

class App extends React.Component {
    editor = React.createRef();
    userDropDown = null;
    toolbarSettings= { items: ['AICommands', 'AIQuery'] };
    aiAssistantSettings= {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    onAIAssistantToolbarClick = (args) => {
        if (args.item.iconCss === 'e-icons e-open-link') {
            const target = args.originalEvent.target;
            const promptContainer = target.closest('.e-prompt-container');
            const prompt = promptContainer.querySelector('.e-prompt-text').textContent;
            window.open(`https://www.google.com/search?q=${prompt}`, '_blank')
        } else if (args.item.iconCss === 'e-icons e-save') {
            const response = (args).event.currentTarget.closest('.e-output-container').querySelector('.e-content-body').innerHTML;
            console.log(response); // Handle Saving response here.
        }
    };
    beforePopupOpen = (event) => {
        if (event.type === 'AIAssistant') {
            this.userDropDown = new DropDownButton({
                items: [
                    { text: 'Usage', iconCss: 'e-icons e-chart' },
                    { text: 'Saved Response', iconCss: 'e-icons e-save' },
                    { separator: true },
                    { text: 'Log out', iconCss: 'e-icons e-view-side' }
                ],
                iconCss: 'e-icons e-user',
                cssClass: 'e-caret-hide',
            }, event.element.querySelector('#profileDropDown'));
        }
    }
    beforePopupClose = (event) => {
        if (event.type === 'AIAssistant') {
            this.userDropDown.destroy();
        }
    }
    render() {
        return (
            <div>
                <RichTextEditorComponent ref={this.editor} toolbarSettings={this.toolbarSettings} aiAssistantSettings={this.aiAssistantSettings} aiAssistantToolbarClick={this.onAIAssistantToolbarClick} beforePopupOpen={this.beforePopupOpen} beforePopupClose={this.beforePopupClose}>
                    <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
                </RichTextEditorComponent>
            </div>
        );
    }
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import type { AIAssitantToolbarClickEventArgs, BeforePopupOpenCloseEventArgs } from '@syncfusion/ej2-react-richtexteditor';
import { DropDownButton } from '@syncfusion/ej2-splitbuttons';
import * as React from 'react';

class App extends React.Component<{}, {}> {
    private editor = React.createRef<RichTextEditorComponent>();
    private userDropDown: DropDownButton;
    private toolbarSettings: object = { items: ['AICommands', 'AIQuery'] };
    private aiAssistantSettings: object = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    private onAIAssistantToolbarClick = (args: AIAssitantToolbarClickEventArgs): void => {
        if (args.item.iconCss === 'e-icons e-open-link') {
            const target: HTMLElement = args.originalEvent.target as HTMLElement;
            const promptContainer: HTMLElement = target.closest('.e-prompt-container') as HTMLElement;
            const prompt = (promptContainer.querySelector('.e-prompt-text') as HTMLElement).textContent;
            window.open(`https://www.google.com/search?q=${prompt}`, '_blank')
        } else if (args.item.iconCss === 'e-icons e-save') {
            const response = (args as any).event.currentTarget.closest('.e-output-container').querySelector('.e-content-body').innerHTML;
            console.log(response); // Handle Saving response here.
        }
    };
    private beforePopupOpen = (event: BeforePopupOpenCloseEventArgs): void => {
        if (event.type === 'AIAssistant') {
            this.userDropDown = new DropDownButton({
                items: [
                    { text: 'Usage', iconCss: 'e-icons e-chart' },
                    { text: 'Saved Response', iconCss: 'e-icons e-save' },
                    { separator: true },
                    { text: 'Log out', iconCss: 'e-icons e-view-side' }
                ],
                iconCss: 'e-icons e-user',
                cssClass: 'e-caret-hide',
            }, event.element.querySelector('#profileDropDown') as HTMLButtonElement);
        }
    }
    private beforePopupClose = (event: BeforePopupOpenCloseEventArgs): void => {
        if (event.type === 'AIAssistant') {
            this.userDropDown.destroy();
        }
    }
    public render() {
        return (
            <div>
                <RichTextEditorComponent ref={this.editor} toolbarSettings={this.toolbarSettings} aiAssistantSettings={this.aiAssistantSettings} aiAssistantToolbarClick={this.onAIAssistantToolbarClick} beforePopupOpen={this.beforePopupOpen} beforePopupClose={this.beforePopupClose}>
                    <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
                </RichTextEditorComponent>
            </div>
        );
    }
}
export default App;
<!DOCTYPE html>
<html lang="en">

<head>
    <title> Syncfusion React Rich Text Editor </title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-icons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-interactive-chat/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-notifications/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-richtexteditor/styles/tailwind3.css" rel="stylesheet" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='sample' style="margin: 20px auto 0;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

[Functional-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import { DropDownButton } from '@syncfusion/ej2-splitbuttons';
import * as React from 'react';

function App() {

    const editor = React.createRef();
    let userDropDown;
    const toolbarSettings = { items: ['AICommands', 'AIQuery'] };
    const aiAssistantSettings = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    const onAIAssistantToolbarClick = (args) => {
        if (args.item.iconCss === 'e-icons e-open-link') {
            const target = args.originalEvent.target;
            const promptContainer = target.closest('.e-prompt-container');
            const prompt = promptContainer.querySelector('.e-prompt-text').textContent;
            window.open(`https://www.google.com/search?q=${prompt}`, '_blank')
        } else if (args.item.iconCss === 'e-icons e-save') {
            const response = (args).event.currentTarget.closest('.e-output-container').querySelector('.e-content-body').innerHTML;
            console.log(response); // Handle Saving response here.
        }
    };
    const beforePopupOpen = (event) => {
        if (event.type === 'AIAssistant') {
            userDropDown = new DropDownButton({
                items: [
                    { text: 'Usage', iconCss: 'e-icons e-chart' },
                    { text: 'Saved Response', iconCss: 'e-icons e-save' },
                    { separator: true },
                    { text: 'Log out', iconCss: 'e-icons e-view-side' }
                ],
                iconCss: 'e-icons e-user',
                cssClass: 'e-caret-hide',
            }, event.element.querySelector('#profileDropDown'));
        }
    }
    const beforePopupClose = (event) => {
        if (event.type === 'AIAssistant') {
            userDropDown.destroy();
        }
    }
    return (
        <div>
            <RichTextEditorComponent ref={editor} toolbarSettings={toolbarSettings} aiAssistantSettings={aiAssistantSettings} aiAssistantToolbarClick={onAIAssistantToolbarClick} beforePopupOpen={beforePopupOpen} beforePopupClose={beforePopupClose}>
                <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
            </RichTextEditorComponent>
        </div>
    );
}

export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import type { AIAssitantToolbarClickEventArgs, BeforePopupOpenCloseEventArgs } from '@syncfusion/ej2-react-richtexteditor';
import { DropDownButton } from '@syncfusion/ej2-splitbuttons';
import * as React from 'react';

function App() {

    const editor = React.createRef<RichTextEditorComponent>();
    let userDropDown: DropDownButton;
    const toolbarSettings: object = { items: ['AICommands', 'AIQuery'] };
    const aiAssistantSettings: object = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    const onAIAssistantToolbarClick = (args: AIAssitantToolbarClickEventArgs): void => {
        if (args.item.iconCss === 'e-icons e-open-link') {
            const target: HTMLElement = args.originalEvent.target as HTMLElement;
            const promptContainer: HTMLElement = target.closest('.e-prompt-container') as HTMLElement;
            const prompt = (promptContainer.querySelector('.e-prompt-text') as HTMLElement).textContent;
            window.open(`https://www.google.com/search?q=${prompt}`, '_blank')
        } else if (args.item.iconCss === 'e-icons e-save') {
            const response = (args as any).event.currentTarget.closest('.e-output-container').querySelector('.e-content-body').innerHTML;
            console.log(response); // Handle Saving response here.
        }
    };
    const beforePopupOpen = (event: BeforePopupOpenCloseEventArgs): void => {
        if (event.type === 'AIAssistant') {
            userDropDown = new DropDownButton({
                items: [
                    { text: 'Usage', iconCss: 'e-icons e-chart' },
                    { text: 'Saved Response', iconCss: 'e-icons e-save' },
                    { separator: true },
                    { text: 'Log out', iconCss: 'e-icons e-view-side' }
                ],
                iconCss: 'e-icons e-user',
                cssClass: 'e-caret-hide',
            }, event.element.querySelector('#profileDropDown') as HTMLButtonElement);
        }
    }
    const beforePopupClose = (event: BeforePopupOpenCloseEventArgs): void => {
        if (event.type === 'AIAssistant') {
            userDropDown.destroy();
        }
    }
    return (
        <div>
            <RichTextEditorComponent ref={editor} toolbarSettings={toolbarSettings} aiAssistantSettings={aiAssistantSettings} aiAssistantToolbarClick={onAIAssistantToolbarClick} beforePopupOpen={beforePopupOpen} beforePopupClose={beforePopupClose}>
                <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
            </RichTextEditorComponent>
        </div>
    );
}

export default App;
<!DOCTYPE html>
<html lang="en">

<head>
    <title> Syncfusion React Rich Text Editor </title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-icons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-interactive-chat/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-notifications/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-richtexteditor/styles/tailwind3.css" rel="stylesheet" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='sample' style="margin: 20px auto 0;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Styling the Popup

The AI Assistant Popup can be styled by using the following css.

.e-rte-aiquery-popup {
    padding:2px;
}

The AI Assistant Popup processing state can be styled by using the following css.

.e-rte-aiquery-popup.processing {
    padding:2px;
    color: white;
    background: white;
    z-index: 1;
}

Example

In the following example, a CSS animation is applied to the popup while the request is in progress.

[Class-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';


class App extends React.Component{
    editor = React.createRef();
    toolbarSettings = { items: ['AICommands', 'AIQuery'] };
    onPromptRequest = () => {
        setTimeout(() => {
            this.editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', false);
            this.editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', true);
        }, 5000);
    };
    render() {
        return (
            <div>
                <RichTextEditorComponent ref={this.editor} toolbarSettings={this.toolbarSettings} aiAssistantPromptRequest={this.onPromptRequest}>
                    <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
                </RichTextEditorComponent>
            </div>
        );
    }
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';


class App extends React.Component<{}, {}> {
    private editor = React.createRef<RichTextEditorComponent>();
    private toolbarSettings: object = { items: ['AICommands', 'AIQuery'] };
    private onPromptRequest = (): void => {
        setTimeout(() => {
            this.editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', false);
            this.editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', true);
        }, 5000);
    };
    public render() {
        return (
            <div>
                <RichTextEditorComponent ref={this.editor} toolbarSettings={this.toolbarSettings} aiAssistantPromptRequest={this.onPromptRequest}>
                    <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
                </RichTextEditorComponent>
            </div>
        );
    }
}
export default App;
<!DOCTYPE html>
<html lang="en">

<head>
    <title> Syncfusion React Rich Text Editor </title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-icons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-interactive-chat/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-notifications/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-richtexteditor/styles/tailwind3.css" rel="stylesheet" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='sample' style="margin: 20px auto 0;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

[Functional-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

function App() {
    const editor = React.createRef();
    const toolbarSettings = { items: ['AICommands', 'AIQuery'] };
    const onPromptRequest = () => {
        setTimeout(() => {
            editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', false);
            editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', true);
        }, 5000);
    };
    return (
        <div>
            <RichTextEditorComponent ref={editor} toolbarSettings={toolbarSettings} aiAssistantPromptRequest={onPromptRequest}>
                <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
            </RichTextEditorComponent>
        </div>
    );
}

export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

function App() {
    const editor = React.createRef<RichTextEditorComponent>();
    const toolbarSettings: object = { items: ['AICommands', 'AIQuery'] };
    const onPromptRequest = (): void => {
        setTimeout(() => {
            editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', false);
            editor.current?.addAIPromptResponse('Demonstration of the AI Assistant Popup styling.', true);
        }, 5000);
    };
    return (
        <div>
            <RichTextEditorComponent ref={editor} toolbarSettings={toolbarSettings} aiAssistantPromptRequest={onPromptRequest}>
                <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
            </RichTextEditorComponent>
        </div>
    );
}

export default App;
<!DOCTYPE html>
<html lang="en">

<head>
    <title> Syncfusion React Rich Text Editor </title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-icons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-interactive-chat/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-notifications/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-richtexteditor/styles/tailwind3.css" rel="stylesheet" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='sample' style="margin: 20px auto 0;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Use Case

Using the public methods, you can build custom workflows with the AI Assistant. Actions such as retrieving conversation history, executing prompts, adding responses, showing or hiding the AI Assistant, and clearing conversation history can all be achieved using the following public methods programmatically.

Method Description
getAIPromptHistory() Get conversation history.
executeAIPrompt(prompt: string) Send a prompt to the AI Assistant.
addAIPromptResponse(outputResponse: string \| Object, isFinalUpdate?: boolean) Adds the Response to the AI Assistant.
showAIAssistantPopup() Show the AI Assistant popup.
hideAIAssistantPopup() Hide the AI Assistant popup.
clearAIPromptHistory() Clear all conversation history.

Example

The following example demonstrates a Proofread use case by rendering a button outside the editor. On clicking the Proofread button:

  1. Launches the AI Assistant popup using the showAIAssistantPopup method.
  2. Executes a prompt using the executeAIPrompt method.

[Class-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

class App extends React.Component {
    editor = React.createRef();
    toolbarSettings = { items: ['AICommands', 'AIQuery'] };
    aiAssistantSettings = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    onPromptRequest = () => {
        setTimeout(() => {
            const aiResponse = `Dear Valued Customer,
We are writing to inform you that there has been a recent change to our policies that may affect your account. Please take a moment to review the details below carefully.
Starting next Monday, all users must update their personal information before accessing the system. Failure to do so may result in the temporary suspension of your account and loss of access to certain features.
If you have any questions or concerns, please feel free to contact our support team at [[email protected]](mailto:[email protected]). They are available 24/7 and happy to help.
Thank you for your time and cooperation. We apologize for any inconvenience this may cause.
Best regards,
Customer Support Team
Company Name
`;
            this.editor.current?.addAIPromptResponse(aiResponse, false);
            this.editor.current?.addAIPromptResponse(aiResponse, true);
        }, 300); // For demonstration purpose.
    };
    reviewContent = () => {
        this.editor.current?.showAIAssistantPopup();
        this.editor.current?.executeAIPrompt('Proof read the editor content.');
    };
    render() {
        return (
            <div>
                <RichTextEditorComponent ref={this.editor} toolbarSettings={this.toolbarSettings} aiAssistantSettings={this.aiAssistantSettings} aiAssistantPromptRequest={this.onPromptRequest}>
                    <p>Dear valued costumer,</p>
                    <p>We are writting to inform you that there has been a recent change to our policys which may effect your account. Please take a moment to review the detials below carefuly.</p>
                    <p>Starting from next monday, all user must update there personal information before accessing the system. Failure to do so may result in temporary suspension of youre account, and loss of acces to certain feature.</p>
                    <p>If you have any question or concern, feel free to contact our support team at <a href="mailto:support&#64;companyname.com">support&#64;companyname.com</a> they are avalible 24/7 and happy help.</p>
                    <p>Thank you for youre time and coorperation. We appologize for any inconvenient this may cause.</p>
                    <p>Best Regard,</p>
                    <p>Customer Support Team</p>
                    <p>Company Name</p>
                    <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
                </RichTextEditorComponent>
                <br />
                <button className="e-btn e-primary" onClick={this.reviewContent}><span className="e-icons e-btn-icon e-check-large"></span>Proof read</button>
            </div>
        );
    }
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

class App extends React.Component<{}, {}> {
    private editor = React.createRef<RichTextEditorComponent>();
    private toolbarSettings: object = { items: ['AICommands', 'AIQuery'] };
    private aiAssistantSettings: object = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    private onPromptRequest = (): void => {
        setTimeout(() => {
            const aiResponse: string = `Dear Valued Customer,
We are writing to inform you that there has been a recent change to our policies that may affect your account. Please take a moment to review the details below carefully.
Starting next Monday, all users must update their personal information before accessing the system. Failure to do so may result in the temporary suspension of your account and loss of access to certain features.
If you have any questions or concerns, please feel free to contact our support team at [[email protected]](mailto:[email protected]). They are available 24/7 and happy to help.
Thank you for your time and cooperation. We apologize for any inconvenience this may cause.
Best regards,
Customer Support Team
Company Name
`;
            this.editor.current?.addAIPromptResponse(aiResponse, false);
            this.editor.current?.addAIPromptResponse(aiResponse, true);
        }, 300); // For demonstration purpose.
    };
    private reviewContent = (): void => {
        this.editor.current?.showAIAssistantPopup();
        this.editor.current?.executeAIPrompt('Proof read the editor content.');
    };
    public render() {
        return (
            <div>
                <RichTextEditorComponent ref={this.editor} toolbarSettings={this.toolbarSettings} aiAssistantSettings={this.aiAssistantSettings} aiAssistantPromptRequest={this.onPromptRequest}>
                    <p>Dear valued costumer,</p>
                    <p>We are writting to inform you that there has been a recent change to our policys which may effect your account. Please take a moment to review the detials below carefuly.</p>
                    <p>Starting from next monday, all user must update there personal information before accessing the system. Failure to do so may result in temporary suspension of youre account, and loss of acces to certain feature.</p>
                    <p>If you have any question or concern, feel free to contact our support team at <a href="mailto:support&#64;companyname.com">support&#64;companyname.com</a> they are avalible 24/7 and happy help.</p>
                    <p>Thank you for youre time and coorperation. We appologize for any inconvenient this may cause.</p>
                    <p>Best Regard,</p>
                    <p>Customer Support Team</p>
                    <p>Company Name</p>
                    <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
                </RichTextEditorComponent>
                <br />
                <button className="e-btn e-primary" onClick={this.reviewContent}><span className="e-icons e-btn-icon e-check-large"></span>Proof read</button>
            </div>
        );
    }
}
export default App;
<!DOCTYPE html>
<html lang="en">

<head>
    <title> Syncfusion React Rich Text Editor </title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-icons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-interactive-chat/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-notifications/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-richtexteditor/styles/tailwind3.css" rel="stylesheet" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='sample' style="margin: 20px auto 0;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

[Functional-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

function App() {
    const editor = React.createRef();
    const toolbarSettings = { items: ['AICommands', 'AIQuery'] };
    const aiAssistantSettings = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    const onPromptRequest = () => {
        setTimeout(() => {
            const aiResponse = `Dear Valued Customer,
We are writing to inform you that there has been a recent change to our policies that may affect your account. Please take a moment to review the details below carefully.
Starting next Monday, all users must update their personal information before accessing the system. Failure to do so may result in the temporary suspension of your account and loss of access to certain features.
If you have any questions or concerns, please feel free to contact our support team at [[email protected]](mailto:[email protected]). They are available 24/7 and happy to help.
Thank you for your time and cooperation. We apologize for any inconvenience this may cause.
Best regards,
Customer Support Team
Company Name
`;
            editor.current?.addAIPromptResponse(aiResponse, false);
            editor.current?.addAIPromptResponse(aiResponse, true);
        }, 300); // For demonstration purpose.
    };
    const reviewContent = () => {
        editor.current?.showAIAssistantPopup();
        editor.current?.executeAIPrompt('Proof read the editor content.');
    };
    return (
        <div>
            <RichTextEditorComponent ref={editor} toolbarSettings={toolbarSettings} aiAssistantSettings={aiAssistantSettings} aiAssistantPromptRequest={onPromptRequest}>
                <p>Dear valued costumer,</p>
                <p>We are writting to inform you that there has been a recent change to our policys which may effect your account. Please take a moment to review the detials below carefuly.</p>
                <p>Starting from next monday, all user must update there personal information before accessing the system. Failure to do so may result in temporary suspension of youre account, and loss of acces to certain feature.</p>
                <p>If you have any question or concern, feel free to contact our support team at <a href="mailto:support&#64;companyname.com">support&#64;companyname.com</a> they are avalible 24/7 and happy help.</p>
                <p>Thank you for youre time and coorperation. We appologize for any inconvenient this may cause.</p>
                <p>Best Regard,</p>
                <p>Customer Support Team</p>
                <p>Company Name</p>
                <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
            </RichTextEditorComponent>
            <br />
            <button className="e-btn e-primary" onClick={reviewContent}><span className="e-icons e-btn-icon e-check-large"></span>Proof read</button>
        </div>
    );
}

export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, AIAssistant } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

function App() {
    const editor = React.createRef<RichTextEditorComponent>();
    const toolbarSettings: object = { items: ['AICommands', 'AIQuery'] };
    const aiAssistantSettings: object = {
        promptToolbarSettings: ['Edit', 'Copy', { command: 'Prompt', subCommand: 'Search', iconCss: 'e-icons e-open-link', tooltip: 'Search in Google' }],
        responseToolbarSettings: [{ command: 'Response', subCommand: 'Save', iconCss: 'e-icons e-save', tooltip: 'Save Response' }, 'Regenerate', 'Copy', '|', 'Insert'],
        headerToolbarSettings: ['AIcommands',
            { command: 'Header', subCommand: 'Profile', template: '<button id="profileDropDown" class="e-rte-dropdown-menu"></button>', align: 'Right' }, 'Close',],
        prompts: [
            {
                prompt: 'What is Essential Studio ?',
                response:
                    'Essential Studio is a software toolkit by Syncfusion that offers a variety of UI controls, frameworks, and libraries for developing applications on web, desktop, and mobile platforms. It aims to streamline application development with customizable, pre-built components.',
            },
        ],
    };
    const onPromptRequest = (): void => {
        setTimeout(() => {
            const aiResponse: string = `Dear Valued Customer,
We are writing to inform you that there has been a recent change to our policies that may affect your account. Please take a moment to review the details below carefully.
Starting next Monday, all users must update their personal information before accessing the system. Failure to do so may result in the temporary suspension of your account and loss of access to certain features.
If you have any questions or concerns, please feel free to contact our support team at [[email protected]](mailto:[email protected]). They are available 24/7 and happy to help.
Thank you for your time and cooperation. We apologize for any inconvenience this may cause.
Best regards,
Customer Support Team
Company Name
`;
            editor.current?.addAIPromptResponse(aiResponse, false);
            editor.current?.addAIPromptResponse(aiResponse, true);
        }, 300); // For demonstration purpose.
    };
    const reviewContent = (): void => {
        editor.current?.showAIAssistantPopup();
        editor.current?.executeAIPrompt('Proof read the editor content.');
    };
    return (
        <div>
            <RichTextEditorComponent ref={editor} toolbarSettings={toolbarSettings} aiAssistantSettings={aiAssistantSettings} aiAssistantPromptRequest={onPromptRequest}>
                <p>Dear valued costumer,</p>
                <p>We are writting to inform you that there has been a recent change to our policys which may effect your account. Please take a moment to review the detials below carefuly.</p>
                <p>Starting from next monday, all user must update there personal information before accessing the system. Failure to do so may result in temporary suspension of youre account, and loss of acces to certain feature.</p>
                <p>If you have any question or concern, feel free to contact our support team at <a href="mailto:support&#64;companyname.com">support&#64;companyname.com</a> they are avalible 24/7 and happy help.</p>
                <p>Thank you for youre time and coorperation. We appologize for any inconvenient this may cause.</p>
                <p>Best Regard,</p>
                <p>Customer Support Team</p>
                <p>Company Name</p>
                <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, AIAssistant]} />
            </RichTextEditorComponent>
            <br />
            <button className="e-btn e-primary" onClick={reviewContent}><span className="e-icons e-btn-icon e-check-large"></span>Proof read</button>
        </div>
    );
}

export default App;
<!DOCTYPE html>
<html lang="en">

<head>
    <title> Syncfusion React Rich Text Editor </title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-icons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-interactive-chat/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-notifications/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-richtexteditor/styles/tailwind3.css" rel="stylesheet" />

    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='sample' style="margin: 20px auto 0;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>